#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "libRTEA.h"

#define MAX_STR_LEN     256

RTEAcodec aCodec;
teaKeyString EnDeKey = "TestKey";

char SrcBuff[MAX_STR_LEN] = "LibRTEA is a simple TEA class source code to easy encode and decode a string.\n"
                            "it keeps standard C++ argument and can build any C++ compilers.\n"
                            "by rageworx@gmail.com\n";
char EncBuff[MAX_STR_LEN] = {0};
char OutBuff[MAX_STR_LEN] = {0};

const char HexChars[] = "0123456789ABCDEF";

void printHexCodes(char* pBuff, int Len)
{
    int nW = 0;

    for(int cnt=0; cnt<Len; cnt++)
    {
        printf(" %02x",(unsigned char)pBuff[cnt]);
        nW++;
        if(nW>15)
        {
            printf("\n");
            nW = 0;
        }
    }
}

int main(int argc, char *argv[])
{
    printf("0. Source String *\n");
    printf("%s",SrcBuff);

    printf("\n======================================\n");

    printf("1. Encoding\n");
    aCodec.EncodeBuffer(SrcBuff,EncBuff,MAX_STR_LEN,&EnDeKey);

    printf("\n======================================\n");

    printf("2. Encoded Result :\n");
    printHexCodes(EncBuff,MAX_STR_LEN);

    printf("\n======================================\n");

    printf("3. Decoding\n");
    aCodec.Decodebuffer(EncBuff,OutBuff,MAX_STR_LEN,&EnDeKey);

    printf("\n======================================\n");

    printf("4. Decoded Result :\n");
    printf("%s",OutBuff);

    printf("\n======================================\n");

    return 0;
}
