///////////////////////////////////////////////////////////////////////////////
//
// libRTEA
//   : a encrypt/decrypt class tool for RAW data.
// ===========================================================================
//
// (C) Copyright 2011 ,  rageworx@gamil.com
//
///////////////////////////////////////////////////////////////////////////////
#pragma once
#ifndef __LIBRTEA_H__
#define __LIBRTEA_H__

typedef char teaKeyString[16];

class RTEAcodec
{
    private:
        void encipher(const unsigned long *v,unsigned long *w, const unsigned long *k);
        void decipher(const unsigned long *v,unsigned long *w, const unsigned long *k);

    public:
        RTEAcodec() {};
        virtual ~RTEAcodec() {};

    public:
        void EncodeBuffer(char* BuffSrc, char* BuffDst, int BufferLen, teaKeyString* Key);
        void Decodebuffer(char* BuffSrc, char* BuffDst, int BufferLen, teaKeyString* Key);
};

#endif // of __LIBRTEA_H__
